Attribute VB_Name = "Global"
Option Explicit

Public Enum enumSortOrders
    Ascending
    Descending
End Enum
         
' API
Public Const NORMAL_PRIORITY_CLASS = &H20&
Public Const INFINITE = -1&

Public Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long

'Windows version
Private Const dwMaskUnknown = &H0&
Private Const dwMask9x = &H1&     'Win95 et 98 renvoient 1
Private Const dwMaskNT = &H2&     'WinNT renvoie 2

Private Type OSVERSIONINFO 'for GetVersionEx API call
    dwOSVersionInfoSize         As Long
    dwMajorVersion              As Long
    dwMinorVersion              As Long
    dwBuildNumber               As Long
    dwPlatformID                As Long
    szCSDVersion                As String * 128
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Private Const OFS_MAXPATHNAME = 128
Public Type OFSTRUCT
    cBytes                  As Byte
    fFixedDisk              As Byte
    nErrCode                As Integer
    Reserved1               As Integer
    Reserved2               As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

' OPENFILE_MODE
Public Const OF_CANCEL = &H800&
Public Const OF_CREATE = &H1000&
Public Const OF_DELETE = &H200&
Public Const OF_EXIST = &H4000&
Public Const OF_PARSE = &H100&
Public Const OF_PROMPT = &H2000&
Public Const OF_READ = &H0&
Public Const OF_READWRITE = &H2&
Public Const OF_REOPEN = &H8000&
Public Const OF_SHARE_COMPAT = &H0&
Public Const OF_SHARE_DENY_NONE = &H40&
Public Const OF_SHARE_DENY_READ = &H30&
Public Const OF_SHARE_DENY_WRITE = &H20&
Public Const OF_SHARE_EXCLUSIVE = &H10&
Public Const OF_VERIFY = &H400&
Public Const OF_WRITE = &H1&

' CreateFile access Flags
Public Const GENERIC_ALL = &H10000000
Public Const GENERIC_EXECUTE = &H20000000
Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000

Public Const OPEN_ALWAYS = 4&
Public Const OPEN_EXISTING = 3&
Public Const CREATE_ALWAYS = 2&

Public Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As Any) As Long
Public Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As Any) As Long
Public Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Const SW_SHOWNORMAL = 1

Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetTempPathA Lib "kernel32" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

' API Declarations for the Locale Methods
' Locale Constants
Private Const LOCALE_SDECIMAL As Long = &HE
Private Const LOCALE_SLONGDATE As Long = &H20
Private Const LOCALE_SSHORTDATE As Long = &H1F
Private Const LOCALE_SCURRENCY As Long = &H14
Private Const LOCALE_STHOUSAND As Long = &HF
Private Const LOCALE_SINTLSYMBOL As Long = &H15
Private Const LOCALE_STIMEFORMAT As Long = &H1003
Private Const LOCALE_SNEGATIVESIGN = &H51
Private Const LOCALE_SPOSITIVESIGN = &H50
Private Const LOCALE_SCOUNTRY As Long = &H6
Private Const LOCALE_SDAYNAME1 As Long = &H2A
Private Const LOCALE_SDAYNAME2 As Long = &H2B
Private Const LOCALE_SDAYNAME3 As Long = &H2C
Private Const LOCALE_SDAYNAME4 As Long = &H2D
Private Const LOCALE_SDAYNAME5 As Long = &H2E
Private Const LOCALE_SDAYNAME6 As Long = &H2F
Private Const LOCALE_SDAYNAME7 As Long = &H30
Private Const LOCALE_SENGCOUNTRY As Long = &H1002
Private Const LOCALE_SENGLANGUAGE As Long = &H1001
Private Const LOCALE_SLANGUAGE As Long = &H2
Private Const LOCALE_SMONTHNAME1 As Long = &H38
Private Const LOCALE_SMONTHNAME10 As Long = &H41
Private Const LOCALE_SMONTHNAME11 As Long = &H42
Private Const LOCALE_SMONTHNAME12 As Long = &H43
Private Const LOCALE_SMONTHNAME2 As Long = &H39
Private Const LOCALE_SMONTHNAME3 As Long = &H3A
Private Const LOCALE_SMONTHNAME4 As Long = &H3B
Private Const LOCALE_SMONTHNAME5 As Long = &H3C
Private Const LOCALE_SMONTHNAME6 As Long = &H3D
Private Const LOCALE_SMONTHNAME7 As Long = &H3E
Private Const LOCALE_SMONTHNAME8 As Long = &H3F
Private Const LOCALE_SMONTHNAME9 As Long = &H40
Private Const LOCALE_SABBREVCTRYNAME = &H7
Private Const LOCALE_SABBREVDAYNAME1 = &H31
Private Const LOCALE_SABBREVDAYNAME3 = &H33
Private Const LOCALE_SABBREVDAYNAME2 = &H32
Private Const LOCALE_SABBREVDAYNAME4 = &H34
Private Const LOCALE_SABBREVDAYNAME5 = &H35
Private Const LOCALE_SABBREVDAYNAME6 = &H36
Private Const LOCALE_SABBREVDAYNAME7 = &H37
Private Const LOCALE_SABBREVLANGNAME = &H3
Private Const LOCALE_SABBREVMONTHNAME1 = &H44
Private Const LOCALE_SABBREVMONTHNAME10 = &H4D
Private Const LOCALE_SABBREVMONTHNAME11 = &H4E
Private Const LOCALE_SABBREVMONTHNAME12 = &H4F
Private Const LOCALE_SABBREVMONTHNAME13 = &H100F
Private Const LOCALE_SABBREVMONTHNAME2 = &H45
Private Const LOCALE_SABBREVMONTHNAME3 = &H46
Private Const LOCALE_SABBREVMONTHNAME4 = &H47
Private Const LOCALE_SABBREVMONTHNAME5 = &H48
Private Const LOCALE_SABBREVMONTHNAME6 = &H49
Private Const LOCALE_SABBREVMONTHNAME7 = &H4A
Private Const LOCALE_SABBREVMONTHNAME8 = &H4B
Private Const LOCALE_SABBREVMONTHNAME9 = &H4C
Private Const LOCALE_SNATIVECTRYNAME = &H8
Private Const LOCALE_SNATIVELANGNAME = &H4

Private Const LOCALE_USER_DEFAULT As Long = &H400

Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal lLocale As Long, ByVal lLocaleType As Long, ByVal sLCData As String, ByVal lBufferLength As Long) As Long

Public Declare Function SetFocusA Lib "user32" Alias "SetFocus" (ByVal hwnd As Long) As Long

Public Declare Function Rectangle Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Function OffsetRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As PEN_STYLES, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function InvalidateRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT, ByVal bErase As Long) As Long
Public Declare Function UpdateWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As SYSCOLOR_FLAGS) As Long
Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Public Declare Function GetFocus Lib "user32" () As Long
Public Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As TEXT_Formats) As Long
Public Declare Function MoveTo Lib "gdi32" Alias "MoveToEx" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpPoint As Long) As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

' Pen functions:
Public Enum PEN_STYLES
    PS_DASH = 1&
    PS_DASHDOT = 3&
    PS_DASHDOTDOT = 4&
    PS_DOT = 2&
    PS_SOLID = 0&
    PS_NULL = 5&
End Enum

' Sys colours:
Public Enum SYSCOLOR_FLAGS
    COLOR_ACTIVEBORDER = 10&
    COLOR_ACTIVECAPTION = 2&
    COLOR_ADJ_MAX = 100&
    COLOR_ADJ_MIN = -100&
    COLOR_APPWORKSPACE = 12&
    COLOR_BACKGROUND = 1&
    COLOR_BTNFACE = 15&
    COLOR_BTNHIGHLIGHT = 20&
    COLOR_BTNSHADOW = 16&
    COLOR_BTNTEXT = 18&
    COLOR_CAPTIONTEXT = 9&
    COLOR_GRAYTEXT = 17&
    COLOR_HIGHLIGHT = 13&
    COLOR_HIGHLIGHTTEXT = 14&
    COLOR_INACTIVEBORDER = 11&
    COLOR_INACTIVECAPTION = 3&
    COLOR_INACTIVECAPTIONTEXT = 19&
    COLOR_MENU = 4&
    COLOR_MENUTEXT = 7&
    COLOR_SCROLLBAR = 0&
    COLOR_WINDOW = 5&
    COLOR_WINDOWFRAME = 6&
    COLOR_WINDOWTEXT = 8&
    COLOR_3DDKSHADOW = 21&
    COLOR_3DLIGHT = 22&
    COLOR_INFOTEXT = 23&
    COLOR_INFOBK = 24&
End Enum

'DrawTex format
Public Enum TEXT_Formats
    DT_LEFT = &H0&
    DT_TOP = &H0&
    DT_CENTER = &H1&
    DT_RIGHT = &H2&
    DT_VCENTER = &H4&
    DT_BOTTOM = &H8&
    DT_CALCRECT = &H400&
    DT_WORDBREAK = &H10&
    DT_TABSTOP = &H80&
    DT_SINGLELINE = &H20&
    DT_NOCLIP = &H100&
    DT_INTERNAL = &H1000&
    DT_EXTERNALLEADING = &H200&
    DT_EXPANDTABS = &H40&
'    DT_CHARSTREAM = 4
    DT_NOPREFIX = &H800&
    DT_EDITCONTROL = &H2000&
    DT_PATH_ELLIPSIS = &H4000&
    DT_END_ELLIPSIS = &H8000&
    DT_MODIFYSTRING = &H10000
    DT_RTLREADING = &H20000
    DT_WORD_ELLIPSIS = &H40000
End Enum

Public Function ValSng(ByVal strVal As String) As Single
    strVal = Replace$(strVal, DecimalSpecifier, ".")
    ValSng = Val(strVal)
End Function

Public Property Get ThousandSpecifier() As String
    'This function returns the correct Thousand Specifier for the system Locale
    ThousandSpecifier = GetLocaleString(LOCALE_STHOUSAND)
End Property

Public Property Get DecimalSpecifier() As String
    'This function returns the correct Decimal Specifier for the system Locale
    DecimalSpecifier = GetLocaleString(LOCALE_SDECIMAL)
End Property

Public Property Get CurrencySpecifier() As String
    'This function returns the correct Currency Specifier for the system Locale
    CurrencySpecifier = GetLocaleString(LOCALE_SCURRENCY)
End Property

Public Property Get PositiveSign() As String
    'Returns the symbol used for the positive sign eg. +
    PositiveSign = GetLocaleString(LOCALE_SPOSITIVESIGN)
End Property

Public Property Get NegativeSign() As String
' Returns the symbol used for the negative sign eg. -
    NegativeSign = GetLocaleString(LOCALE_SNEGATIVESIGN)
End Property

Private Function GetLocaleString(ByVal lLocaleNum As Long) As String
    'Generic routine to get the locale string from the Operating system.
    Dim lBuffSize As String
    Dim sBuffer As String
    Dim lRet As Long

    lBuffSize = 256
    sBuffer = String$(lBuffSize, vbNullChar)

    'Get the information from the registry
    lRet = GetLocaleInfo(LOCALE_USER_DEFAULT, lLocaleNum, sBuffer, lBuffSize)
    'If lRet > 0 then success - lret is the size of the string returned
    If lRet > 0 Then
        GetLocaleString = Left$(sBuffer, lRet - 1)
    End If
End Function

Public Function IsWin9x() As Boolean
    IsWin9x = (Not GetWinPlatform And dwMaskNT)
End Function

Private Function GetWinPlatform() As Long
    Dim tOSVI           As OSVERSIONINFO
    
On Error GoTo ErrorFlag

    tOSVI.dwOSVersionInfoSize = Len(tOSVI)
    If GetVersionEx(tOSVI) = 0 Then
        Exit Function
    End If
    GetWinPlatform = tOSVI.dwPlatformID

ErrorFlag:
End Function

Public Function GetTempPath() As String
    Dim lRc     As Long
    Dim strPath As String

On Error GoTo ErrorFlag

    strPath = String$(260, vbNullChar)
     
    lRc = GetTempPathA(260, strPath)
    If lRc <> 0 Then            ' Not error indicates success or small buffer
        If lRc <= 260 Then
            GetTempPath = Left$(strPath, lRc)
        Else
            GetTempPath = Left$(strPath, 260)   ' small buffer
        End If
    Else
        GetTempPath = vbNullString
    End If

Exit Function
ErrorFlag:
    Debug.Print "GetTempPath", "Erreur ", Err.Description, Err.Number
    Debug.Assert False
End Function

Public Function GetTempFile(Optional lUnique As Long = 0) As String
    Dim lRc         As Long
    Dim strFile     As String
    Dim strPref     As String
    Dim strPath     As String
    Dim lNullPos    As Long
    
On Error GoTo ErrorFlag

    GetTempFile = vbNullString
    strPath = GetTempPath
    strPref = App.EXEName
    strFile = String$(260, vbNullChar)
     
    lRc = GetTempFileName(strPath, strPref, lUnique, strFile)
    If lRc <> 0 Then            ' Not error indicates success or small buffer
        lNullPos = InStr(strFile, vbNullChar)
        If lNullPos > 0 Then
            GetTempFile = Left$(strFile, lNullPos - 1)
        End If
    End If

Exit Function
ErrorFlag:
    Debug.Print "GetTempFile", "Erreur ", Err.Description, Err.Number
    Debug.Assert False
End Function


